import common_utils
import json
import xml.etree.ElementTree as ET
from xml.dom.minidom import parseString
from flask import session
import config
import run
#from Manager import Manager
"""
{
    "action":true,
    "data":[
        {
            "status":"Master",
            "id":"ns187",
            "is_dc":true
        },
        {
            "status":"Not Running/Standby",
            "id":"ns188",
            "is_dc":false
        }
    ]
}
"""


def get_node_info():
    data = []
    status, output = common_utils.run_cmd("crm_mon --as-xml")
    if status != 0:
        nodeoffline = config.get_hb_by_hosts()
        if nodeoffline['action'] and 'hbaddrs1' in nodeoffline['data']:
            data = []
            nodes = nodeoffline['data']['hbaddrs1']
            for node in nodes:
                nodeinfo = {}
                nodeinfo['id'] = node['nodeid']
                nodeinfo['status'] = 'Not Running'
                nodeinfo['is_dc'] = 'false'
                data.append(nodeinfo)
            if data != []:
                return {"action": True, "data": data}
        else:
            return {'action': False, 'error': _("请确定集群节点已认证！")}

    new_nodes = parseString(output).documentElement
    for nodes in new_nodes.getElementsByTagName('nodes'):
        for node in nodes.getElementsByTagName('node'):
            name = node.getAttribute('name')
            id = node.getAttribute('id')
            online = node.getAttribute('online')
            standby = node.getAttribute('standby')
            is_dc = node.getAttribute('is_dc')
            status = ""
            if is_dc == "true":
                if standby == "true":
                    if online == "true":
                        status = "Master/Standby"
                    else:
                        status = "Not Running"
                else:
                    if online == "true":
                        status = "Master"
                    else:
                        status = "Not Running"
            else:
                if standby == "true":
                    if online == "true":
                        status = "Standby"
                    else:
                        status = "Not Running"
                else:
                    if online == "true":
                        status = "Running"
                    else:
                        status = "Not Running"

            status_json = {}
            status_json['id'] = name
            status_json['status'] = status
            status_json['is_dc'] = is_dc
            data.append(status_json)
    if data != []:
        return {"action": True, "data": data}
    else:
        return {"action": False, "data": _("Get node failed!")}


def get_nodeid_info(nodeid):
    nameid = str(nodeid)
    status, output = common_utils.run_cmd("cat /etc/hosts|grep " + nameid +
                                          "|awk -F ' ' '{print $1}'")
    nodeip = str(output)
    if nameid == {}:
        return {'action': False, "data": _("Get nodeid failed!")}
    else:
        return {'action': True, 'data': {'ips': nodeip}}


def get_nodes_action(node_id, action):
    nodeid = str(node_id)
    # 节点未开启
    if nodeid == {} or nodeid is None:
        return {'action': False, 'error': _("Cannot find the")}
    # 备用
    if action == 'standby':
        status, output = common_utils.run_cmd("pcs node standby " + nodeid)
    # 不备用
    if action == 'unstandby':
        status, output = common_utils.run_cmd("pcs node unstandby " + nodeid)
    # 启动
    if action == 'start':
        status, output = common_utils.run_cmd("pcs cluster start " + nodeid +
                                              " &sleep 5")
    # 停止
    if action == 'stop':
        status, output = common_utils.run_cmd("pcs cluster stop " + nodeid)

    # 重启
    if action == 'restart':
        status, output = common_utils.run_cmd("pcs cluster restart " + nodeid)
    if action == {} or action is None:
        return {"action": False, "error": _("Change node status Failed")}
    else:
        return {"action": True, "info": _("Change node status success")}
