# -*-coding:utf-8-*-
# !/usr/bin/python
# coding: iso-8859-15

import json
import os
import re
import common_utils
import stat

manager = None
def send_remote_scripts_request():
    return 
def test_api_alive():
    return

def generate_scripts(data):

    # 获取本地主机id
    status, output = common_utils.run_cmd("hostname")
    if status != 0:
          return {'action': False, 'error': output}
    localnodeid = str(output).strip()
    # configdata = get_hb_config_org(True)
    configdata = None
    hbs = configdata['data']

    hbaddrs = []
    for hb in hbs:
        if 'hbaddrs' in hb:
            hbaddrs = hb['hbaddrs']

    for node in hbaddrs:
        nodeid = node['nodeid']
        if localnodeid != nodeid:
            nodeip = node['ip']
            ret = test_api_alive(nodeip)
            if 'action' not in ret or not ret['action']:
                return {'action': False, 'error': _('Generate script failed, please checkout network and ha service')}

    for node in hbaddrs:
        nodeid = node['nodeid']
        if localnodeid == nodeid:
            generate_local_scripts(data)
        if localnodeid != nodeid:
            nodeip = node['ip']
            retremote = send_remote_scripts_request(data, nodeip)
            if not retremote['action']:
                return  {'action': False, 'error': _('Generate script failed')}
 
    return  {'action': True, 'info': _('Generate script success')} 



def generate_local_scripts(data):

    filename = data['name']
    start_command = data['start']
    stop_command = data['stop']
    monitor_command = data['monitor']
    filename_path = "/usr/lib/ocf/resource.d/pacemaker/" + filename

    script_str = '#!/bin/sh\n\
#\n\
# Author:	CS2C\n\
# License:      GNU General Public License (GPL) \n\
#\n\
#	usage: $0 {start|stop|status|monitor|validate-all|meta-data}\n\
#  OCF parameters:\n\
#\n\
##########################################################################\n\
# Initialization:\n\
#OCF_ROOT="/usr/lib/ocf"\n\
: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}\n\
. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs\n\
#########################################################################\n\
\n\
name="' + filename + '"\n\
start_path="' +  start_command + '"\n\
stop_path="' + stop_command + '"\n\
\n\
meta_data() {\n\
	cat <<END\n\
<?xml version="1.0"?>\n\
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">\n\
<resource-agent name="$name">\n\
<version>1.0</version>\n\
\n\
<longdesc lang="en">\n\
This script manages $name\n\
</longdesc>\n\
<shortdesc lang="en">OCF Resource Agent compliant $name.</shortdesc>\n\
\n\
<parameters>\n\
</parameters>\n\
\n\
<actions>\n\
<action name="start"   timeout="50" />\n\
<action name="stop"    timeout="60" />\n\
<action name="monitor" depth="10"  timeout="15s" interval="30s" start-delay="1s" />\n\
<action name="validate-all"  timeout="30s" />\n\
<action name="meta-data"  timeout="5s" />\n\
</actions>\n\
</resource-agent>\n\
END\n\
}\n\
\n\
anything_status() \n\
{\n\
	ret0=`ps -ef |grep -v grep |grep "' + monitor_command  + '"|wc -l`\n\
	if [ 1  -a $ret0 -gt 0 ]; then\n\
		return $OCF_SUCCESS;\n\
	elif [ 1  -a $ret0 -eq 0 ]; then\n\
		return $OCF_NOT_RUNNING;\n\
	else\n\
		return $OCF_ERR_GENERIC;\n\
	fi\n\
}\n\
\n\
anything_start()\n\
{\n\
    anything_status\n\
    ret=$?\n\
    if [ $ret -eq 0 ]; then\n\
      ocf_log info "$name agent already running"\n\
      return $OCF_SUCCESS;\n\
    else\n\
      $start_path >/dev/null 2>&1\n\
       anything_monitor\n\
       ret1=$?\n\
       if [ $ret1 -eq 0 ]; then\n\
          ocf_log info "$name agent start ok"\n\
          return $OCF_SUCCESS;\n\
       else\n\
          ocf_log info "$name agent start failed"\n\
          return $OCF_ERR_GENERIC;\n\
       fi\n\
  fi\n\
}\n\
\n\
\n\
anything_stop()\n\
{\n\
 anything_status\n\
 ret=$?\n\
 if [ $ret -ne 7 ]; then\n\
#   ocf_log info $ret\n\
   $stop_path >/dev/null 2>&1\n\
   sleep 3 \n\
   anything_monitor\n\
   ret=$?\n\
   if [ $ret -eq 7 ]; then\n\
     ocf_log info "$name agent stop ok"\n\
     return $OCF_SUCCESS;\n\
   else\n\
     ocf_log info "$name agent stop failed"\n\
     return $OCF_ERR_GENERIC;\n\
   fi\n\
 else\n\
   ocf_log info "$name agent not running"\n\
   return $OCF_SUCCESS;\n\
 fi\n\
\n\
}\n\
\n\
anything_monitor()\n\
{\n\
  anything_status\n\
  ret=$?\n\
  #ocf_log info $ret\n\
  if [ $ret -eq 0 ]; then\n\
     ocf_log info " $name is running!"\n\
     return $OCF_SUCCESS\n\
  elif [ $ret -eq 7 ]; then\n\
     ocf_log info "$name is not running" \n\
     return $OCF_NOT_RUNNING\n\
  else\n\
    ocf_log info "$name is failed"\n\
    return $OCF_ERR_GENERIC\n\
  fi\n\
}\n\
\n\
anything_validate()\n\
{\n\
 return $OCF_SUCCESS\n\
}\n\
\n\
case $1 in\n\
    start)	anything_start\n\
		;;\n\
	\n\
    stop)	anything_stop\n\
    		;;\n\
		\n\
    status)	anything_status\n\
    		;;\n\
		\n\
    monitor)	anything_monitor\n\
    		;;\n\
		\n\
    validate-all)	anything_validate\n\
    			exit  $OCF_SUCCESS\n\
    			;;\n\
			\n\
    meta-data)	meta_data\n\
                exit  $OCF_SUCCESS\n\
  		;;\n\
    *)\n\
                ocf_log err "$0 was called with unsupported arguments: $*"\n\
                exit $OCF_ERR_UNIMPLEMENTED\n\
                ;;\n\
esac\n\
exit $?\n\
'
    try:
        file_w = file(filename_path, 'w')
        file_w.write(script_str)
        file_w.close 
        # chmod 755 to scripts
        os.chmod(filename_path, stat.S_IRWXU|stat.S_IRGRP|stat.S_IXGRP|stat.S_IROTH|stat.S_IXOTH)

        return {'action': True, 'info': _('Generate script success!')}
    except:
        return {'action': False, 'error': _('Generate script failed!')} 



